- [HTTP request](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.TranslateYLRuleResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/chronicle/docs/reference/rest/v1alpha/projects.locations.instances/translateYlRule#body.aspect_1)

**Full name**: projects.locations.instances.translateYlRule

Translate natural language to a Yara-L rule.

### HTTP request

`POST https://{endpoint}/v1alpha/{instance}:translateYlRule`

Where `{endpoint}` is one of the [supported service endpoints](https://docs.cloud.google.com/chronicle/docs/reference/rest#rest_endpoints).

### Path parameters

| Parameters ||
|---|---|
| `instance` | `string` Required. The name of the parent resource, which is the SecOps instance associated with the request. Format: projects/{project}/locations/{location}/instances/{instance} |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "text": string, "udmQuery": string } ``` |

| Fields ||
|---|---|
| `text` | `string` Required. Natural language text description for the rule. |
| `udmQuery (deprecated)` | `string` Optional. Deprecated: UDM query generated from the text via instances.translateUdmQuery. |

### Response body

Response message for instances.translateYlRule.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "ruleText": string, "message": string } ``` |

| Fields ||
|---|---|
| `ruleText` | `string` The translated YARA-L rule text. |
| `message` | `string` Optional. The message to be shown to the user if the translation was unsuccessful. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/chronicle`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `instance` resource:

- `chronicle.ais.translateYlRule`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).